#!/usr/dist/pkgs/perl,v5.003/5bin.sun4/perl
require 5.003;

BEGIN {
    ($workdir) = ($0 =~ /(.*)\/.*/);
}
use lib "$workdir/../lib";
my ($workdir) = ($0 =~ /(.*)\/.*/);
use Socket;
use SNMP_MIB;
use SNMP_Simple;
use strict;

my $community = $ARGV[0];

my ($hostname);
SNMP_MIB::loadoids("$workdir/../mibs", "RFC1213", "ESSWITCH");
$SNMP_Simple::suppress_warnings = 0;
$SNMP_Simple::debug = 1;
foreach $hostname (<STDIN>) {
    chomp $hostname;
    next unless defined gethostbyname($hostname);
    my($session) = SNMP_Simple->open($hostname, $community);
    
    next unless defined $session;
    my ($sysObjectID) = $session->snmpget('sysObjectID');
    if (defined $sysObjectID) {
	my $cisco_switch_sysid = '1\.3\.6\.1\.4\.1\.9\.5';
	my $gj_switch_sysid = '1\.3\.6\.1\.4\.1\.437.1.1.3';
	my $filename = undef;

	if ($sysObjectID =~ /^$cisco_switch_sysid/) {
	    my($switchtype) = ($sysObjectID =~ /^$cisco_switch_sysid\.(\d+)/);
	    if (($switchtype == 18)) { #Cat1900
		$filename = "cat1900.537.bin";
	    } elsif (($switchtype == 20)) { #Cat2820
		$filename = "cat2820.537.bin";
	    } elsif (($switchtype == 28)) { #Cat1900i
		$filename = "cat1900A.8.01.02.bin"
	    }
	}
	
	if ($sysObjectID =~ /^$gj_switch_sysid/) {
	    my($switchtype) = ($sysObjectID =~ /^$gj_switch_sysid\.(\d+\.\d+)/);
	    if (($switchtype eq "2.0") # GJ 2800
		|| ($switchtype eq "3.3") # Cat 2800
		){
		$filename = "cat2800.376.bin"
	    }
	}

	if (defined($filename)) {
	    if ($session->snmpset('upgradeTFTPServerAddress', 'ip', '129.150.77.6')) {
		if ($session->snmpset('upgradeTFTPLoadFilename', 'string', $filename)) {
		    if ($session->snmpset('upgradeTFTPInitiate', 'int', 1)) {
			print "$hostname: starting upgrade.\n";
		    } else {
			print "$hostname: Error initating upgrade.\n";
		    }
		} else {
		    print "$hostname: Error on SNMP set of load file.\n";
		}
	    } else {
		print "$hostname: Error on SNMP set of server address.\n";
	    }
	} else {
	    print "$hostname: inappropiate type for upgrade: $sysObjectID\n";
	}
    } else {
	print "$hostname: No SNMP response\n";
    }
    $session->close();
}
exit 0;
